"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentPosition = exports.historyLength = exports.jumpToIndex = exports.clearHistory = exports.getNextWord = exports.getPreviousWord = exports.pushWord = exports.initHistory = void 0;
var historyStack = [];
var currentPosition = 0;
var initHistory = function (history) {
    historyStack = __spreadArray([], history);
    currentPosition = history.length > 0 ? history.length - 1 : 0;
};
exports.initHistory = initHistory;
var pushWord = function (word) {
    if (!word) {
        return null;
    }
    var index = historyStack.findIndex(function (item) { return item === word; });
    if (index >= 0) {
        historyStack.splice(index, 1);
    }
    historyStack.push(word);
    currentPosition = historyStack.length - 1;
    return word;
};
exports.pushWord = pushWord;
var getPreviousWord = function () {
    if (currentPosition === 0) {
        return null;
    }
    currentPosition -= 1;
    return historyStack[currentPosition];
};
exports.getPreviousWord = getPreviousWord;
var getNextWord = function () {
    if (currentPosition >= historyStack.length - 1) {
        return null;
    }
    currentPosition += 1;
    return historyStack[currentPosition];
};
exports.getNextWord = getNextWord;
var clearHistory = function () {
    historyStack.length = 0;
    currentPosition = 0;
};
exports.clearHistory = clearHistory;
var jumpToIndex = function (index) {
    index = +index.toFixed(0);
    if (index < 0 || index > historyStack.length - 1) {
        return null;
    }
    return historyStack[index];
};
exports.jumpToIndex = jumpToIndex;
var historyLength = function () { return historyStack.length; };
exports.historyLength = historyLength;
var getCurrentPosition = function () { return currentPosition; };
exports.getCurrentPosition = getCurrentPosition;
